<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>DEV TOOLS LEARNING</title>
</head>
<body>
  <div id="time">
    <b> <span></span> </b>
  </div>
<h2>DEV TOOLS LEARNING - TIPS AND TRICKS</h2>
<ul>
<h3>Run command line in console:</h3>
<li>
  <p>Go to dev tools than click console type shift+ctrl+p to run command</p>
</li> 
<li>
  <p>To open file go to console and type ctrl + p to open file </p>
</li>
<h2>Web Components:</h2>
<h3> <b>Custom Elements:</b></h3>
<li> <b> We can create custom HTML tags, class 
    for example:</b> <br>
    class TomTag extends HTMLElement {...} <br>
    window.customElements.define('tom-tag', TomTag);
    <!-- <tom-tag> </tom-tag> -->
<p> <b>Example below:</b> </p>

<tom-tag name="Tom's Tag"></tom-tag>
<tom-tag name="Marry's Tag"></tom-tag>
<tom-tag name="Marry's Tag"></tom-tag>
<tom-tag name="Alex's Tag"></tom-tag>

<br>
<br>

</li>
<li> <b>Lifecycle method available:</b> 
  <p>1. constructor(): is called when an instance of the element is created or upgraded</p>
  <p>2. connectedCallback():Called every time when the element is inserted into the DOM</p>
  <p>3. disconnectedCallback():Called every time the element is removed from DOM</p>
  <p>4. atributeChangedCallback(atributeName, oldValue, newValue): Called when an attribute is
    added, removed, updated or replaced</p>
  </li>

<h3> <b>Shadow DOM:</b> </h3>
<li>1. Shadow DOM is web API that allows us to attach hidden DOM (encapsulated, hermetized) to a DOM element.</li> <br>
<li> <b> 2. We can attach Shadow Tree to to DOM using this: </b>
<p> const el = document.createElement('div');   </p> 
<p>
const shadowRoot = el.attachShadow({mode: 'open'});</p>
<p>shadowRoot.innertHTML = "I belong to the Shadow DOM " </p>
<!-- should be "<p> I belong to the Shadow DOM </p>" -->
</li>
<li> <b>3. If you want to query this:</b>
<p>
el.shadowRoot.querySelector('p')
</p>
</li>

<h3> <b>  </b> </h3>

<h2>Elements Tab:</h2>
<h3> <b>Use $0 to select path:</b> </h3>
<li>Steps: Go to elements and click on some element then go to console log and type $0 and you will receive what you have clicked
  <p>You can change text on tags, for exmple you can use this command: $0.innetText = "something else"</p>
</li>

<h3>Copy JS path:</h3>
<li>Steps: go to the DOM tree. select chosem element and click right mouse button and select "copy js path"</li>
<h3>Copy Selector:</h3>
<li>Steps: go to the DOM tree. type ctrl+f to access search bar. select chosem element and click right mouse button and select "copy Selector"</li>
<h3>How to use Event Listener Breakpoints</h3>
<li>Steps: go to Sources than choose the file of your interest</li>
<li>Next thing is to go down the dev Tools and choose Event Listener Breakpoints of your interest</li>
<h3>Using snippet:</h3>
<li>Go to sources and click snippet on the middle-left side of the screen</li>
<li>you can create some JS code and run it typing "Ctrl+Enter"</li>
<h2>Network tab:</h2>
<li> <b>1. Filter Network requests: </b> 
  <p>If you want to display for example only JS and CSS request press crtl and then click on JS and CSS. 
    After reload (ctrl + R) you will see only JS and CSS requests
  </p>
<!-- 1:34 -->
<!-- https://www.youtube.com/watch?v=Y3u2groOG-A -->
</li>
<li> <b>2. Customize column names</b>
  <p> To customize column names press right button on the "name" field and choose what colums you want to display
  </p>
</li>
<li><b>3. Display hidden password from input tag </b>
  <p> To dispaly hidden password in input field you have to change "type" atribute from "password" to "input".
    Of course some password or something must be added to show it !
  </p>   
</li>
<li> <b>4. Copy request as Curl and launch it in POSTMAN </b> 
  <p> Click right on your request and copy as Curl. In POSTMAN click on import and then "Raw text"
    In the "Raw text" field paste all Curl command. It could be long!
  <p> <b>You can copy request as Curl, Fetch, nodejs fetch etc. and exetuce it in console as well!</b> </p>
  </p>
</li>
<li> <b>5. </b> 
  <p> b </p>
</li>
</ul>
<BR></BR>

<H2>DOM OPERATIONS/MANIPULATIONS</H2>
<div class="container">

<div class="boxes">
  <h3>dark/light mode switch </h3>
  <p>Click the button to toggle between dark and light mode</p>
  <button onclick="myFunction()">Switch</button>
  
</div>

<div class="boxes">
  <h3>click to generate math random number</h3>
  <button onclick="random()">Generate</button>
  
</div>
<div class="boxes">
  <h3>click to generate random number list with string</h3>
  <button onclick="typed()">Generate</button>
  <ul class="list"></ul>
</div>

<div class="boxes">
  <h3>click to create p with string</h3>
  <button onclick="create()">create</button>
  
</div>
<div class="boxes">
  <h3>click to create ol with string</h3>
  <button class = "button10" onclick="create2()">create2</button>
  
</div>

<div class="boxes">
  <h3>click create p with string</h3>
  <button onclick="create3()">create3</button>
  <p id="create3"></p>
</div>

<div class="boxes">
  <h3>click to delete elements</h3>
  <div>
  <button onclick="rem1()">delete</button>
  <span id="span1">This text will be deleted!</span>
  
</div>  
</div>

<div class="boxes">
  <h3>set/modify atribute</h3>
  <div>
    <button onclick="modify1()">modify</button>
    <span title="atribute of title" id="modify1">get atribute of span1</span>
  </div>
</div>

<div class="boxes">
  <h3>remove atributes atribute</h3>
  <div>
    <button onclick="modify2()">modify2</button>
    <span title="atribute title" id="modify2">set atribute of span 2</span>
  </div>
</div>

<div class="boxes">
  <h3>remove atributes atribute</h3>
  <div>
    <button onclick="modify3()">modify3</button>
    <span title="atribute title of span3" id="modify3">remove atribute of span 3</span>
  </div>
</div>
<div class="boxes">
  <h3>Adding a class name</h3>
<div>
  <button onclick="modify4()">modify4</button>
  <span title="atribute title of span4" class="modify4">add class of span 4</span>
</div>
</div>

<div class="boxes">
  <h3>Removing a class</h3>
  <div>
    <button onclick="modify5()">modify5</button>
    <span class="class modify5">remove class of span 5</span>
  </div>
</div>

<div class="boxes">
  <h3>Toggle a class name</h3>
  <div>
    <button onclick="modify6()">modify6</button>
    <span class="class modify6">toggle class of span 5</span>
  </div>
</div>
<div class="boxes">
  <h3>Modify style</h3>
  <div>
    <button id="modify7" onclick="modify7()">modify7</button>
    <span class="modify7">this text will be blue after you click</span>
  </div>
</div>

<div class="boxes">
  <div>
    <h3><b>close window</b></h3>
      <button id="close" onclick="functionOne()">close</button>
  </div>
</div>

</div>
</body>
<link rel="stylesheet" href="./css/index.css">
<script src="./js/app.js"></script>
</body>
</html>


<!-- Funkcjonalności DEVTOOLA -->
<!-- 
  # 1. Lokalizacja
  kroki -> trzy kropki -> more tools -> sensors
  #2. Audyty
  lighthouse
  #3 
 -->